module net.BurtonRadons.dig.platform.windows;

/+
#ifdef DOXYGEN_JUST_HURTS_ITSELF_HERE
+/

//private import std.c.windows.windows;

private import net.BurtonRadons.dig.platform.base;

alias _UINT SIZE_T;

//The following list was added by Joel Anderson
alias std.c.windows.windows.BOOL _BOOL;
alias std.c.windows.windows.HANDLE _HANDLE;
alias std.c.windows.windows.WNDCLASS _WNDCLASS;
alias std.c.windows.windows.UINT _UINT;
alias std.c.windows.windows.ULONG _ULONG;
alias std.c.windows.windows.HWND _HWND;
alias std.c.windows.windows.WPARAM _WPARAM;
alias std.c.windows.windows.LPARAM _LPARAM;
alias std.c.windows.windows.DWORD _DWORD ;
alias std.c.windows.windows.LPVOID _LPVOID;
alias std.c.windows.windows.PVOID _PVOID;
alias std.c.windows.windows.WORD _WORD;
alias std.c.windows.windows.LONG _LONG;
alias std.c.windows.windows.LPSTR _LPSTR;
alias std.c.windows.windows.LPCTSTR _LPCTSTR;
alias std.c.windows.windows.LPCWSTR _LPCWSTR;
alias std.c.windows.windows.LPWSTR _LPWSTR;
alias std.c.windows.windows.LPTSTR _LPTSTR;
alias std.c.windows.windows.HMENU _HMENU;
alias std.c.windows.windows.HBITMAP _HBITMAP;
alias std.c.windows.windows.HDC _HDC;
alias std.c.windows.windows.COLORREF _COLORREF;
alias std.c.windows.windows.POINT _POINT;
alias std.c.windows.windows.BYTE _BYTE;
alias std.c.windows.windows.LPBYTE _LPBYTE;
alias std.c.windows.windows.LPCSTR _LPCSTR;
alias std.c.windows.windows.LRESULT _LRESULT;
alias std.c.windows.windows.WNDPROC _WNDPROC;
alias std.c.windows.windows.PIXELFORMATDESCRIPTOR _PIXELFORMATDESCRIPTOR;
alias std.c.windows.windows.BITMAPINFO _BITMAPINFO;
alias std.c.windows.windows.HFONT _HFONT;
alias std.c.windows.windows.HPEN _HPEN;
alias std.c.windows.windows.SECURITY_ATTRIBUTES _SECURITY_ATTRIBUTES;
alias std.c.windows.windows.HRGN _HRGN;
alias std.c.windows.windows.HBRUSH _HBRUSH;
alias std.c.windows.windows.HGDIOBJ _HGDIOBJ;
alias std.c.windows.windows.LPPOINT _LPPOINT;
alias std.c.windows.windows.LPRECT _LPRECT;
alias std.c.windows.windows.RECT _RECT;
alias std.c.windows.windows.LPCVOID _LPCVOID;
alias std.c.windows.windows.LPINT _LPINT;
alias std.c.windows.windows.LPDWORD _LPDWORD;
alias std.c.windows.windows.HINSTANCE _HINSTANCE;
alias std.c.windows.windows.HGLOBAL _HGLOBAL;
alias std.c.windows.windows.HKEY _HKEY;
alias std.c.windows.windows.PHKEY _PHKEY;
alias std.c.windows.windows.HCURSOR _HCURSOR;
alias std.c.windows.windows.PPIXELFORMATDESCRIPTOR _PPIXELFORMATDESCRIPTOR;
alias std.c.windows.windows.HRESULT _HRESULT;
alias std.c.windows.windows.HMODULE _HMODULE;
alias std.c.windows.windows.PAINTSTRUCT _PAINTSTRUCT;
alias std.c.windows.windows.BITMAPINFOHEADER _BITMAPINFOHEADER;
alias std.c.windows.windows.LPMSG _LPMSG;
alias std.c.windows.windows.WIN32_FIND_DATA _WIN32_FIND_DATA;
alias std.c.windows.windows.ATOM _ATOM;

//alias std.stdint.ubyte ubyte;

//End The following list was added by Joel Anderson

alias char TCHAR;
alias _BOOL WINBOOL;
alias _HANDLE HINST;
alias int WINSHORT;
alias int WININT;
alias ubyte BCHAR;
alias void* _POINTER;
alias _HANDLE HDROP;
alias char* PCHAR;
alias _HANDLE HLOCAL;
alias _ULONG LARGE_INTEGER;
alias _HANDLE HTHEME;
alias _HANDLE HIMAGELIST;
//alias wchar* _LPWSTR;
alias _POINTER FARPROC;
alias FARPROC PROC;
alias int* intptr_t;
alias _WNDCLASS* LP_WNDCLASS;
alias _ULONG* _ULONG_PTR;

extern(Windows) alias _UINT (*LPOFNHOOKPROC)(_HWND, _UINT, _WPARAM, _LPARAM);
extern(Windows) alias _UINT (*LPCFHOOKPROC)(_HWND, _UINT, _WPARAM, _LPARAM);
extern(Windows) alias _UINT (*LPCCHOOKPROC)(_HWND, _UINT, _WPARAM, _LPARAM);
extern(Windows) alias void (*TIMERPROC)(_HWND, _UINT, _UINT);

const int BDR_RAISEDINNER = (4);
const int BDR_RAISEDOUTER = (1);
const int BDR_SUNKENOUTER = (1);
const int BDR_SUNKENINNER = (8);

const int BF_ADJUST = (8192);
const int BF_BOTTOM = (8);
const int BF_BOTTOMLEFT = (9);
const int BF_BOTTOMRIGHT = (12);
const int BF_DIAGONAL = (16);
const int BF_DIAGONAL_ENDBOTTOMLEFT = (25);
const int BF_DIAGONAL_ENDBOTTOMRIGHT = (28);
const int BF_DIAGONAL_ENDTOPLEFT = (19);
const int BF_DIAGONAL_ENDTOPRIGHT = (22);
const int BF_FLAT = (16384);
const int BF_LEFT = (1);
const int BF_MIDDLE = (2048);
const int BF_MONO = (32768);
const int BF_RECT = (15);
const int BF_RIGHT = (4);
const int BF_SOFT = (4096);
const int BF_TOP = (2);
const int BF_TOPLEFT = (3);
const int BF_TOPRIGHT = (6);

const int BI_RGB = (0);

const int CB_ERR = -((1));

const int CB_ADDSTRING = (323);
const int CB_DELETESTRING = (324);
const int CB_DIR = (325);
const int CB_FINDSTRING = (332);
const int CB_FINDSTRINGEXACT = (344);
const int CB_GETCOUNT = (326);
const int CB_GETCURSEL = (327);
const int CB_GETDROPPEDCONTROL_RECT = (338);
const int CB_GETDROPPEDSTATE = (343);
const int CB_GETDROPPEDWIDTH = (351);
const int CB_GETEDITSEL = (320);
const int CB_GETEXTENDEDUI = (342);
const int CB_GETHORIZONTALEXTENT = (349);
const int CB_GETITEMDATA = (336);
const int CB_GETITEMHEIGHT = (340);
const int CB_GETLBTEXT = (328);
const int CB_GETLBTEXTLEN = (329);
const int CB_GETLOCALE = (346);
const int CB_GETTOPINDEX = (347);
const int CB_INITSTORAGE = (353);
const int CB_INSERTSTRING = (330);
const int CB_LIMITTEXT = (321);
const int CB_RESETCONTENT = (331);
const int CB_SELECTSTRING = (333);
const int CB_SETCURSEL = (334);
const int CB_SETDROPPEDWIDTH = (352);
const int CB_SETEDITSEL = (322);
const int CB_SETEXTENDEDUI = (341);
const int CB_SETHORIZONTALEXTENT = (350);
const int CB_SETITEMDATA = (337);
const int CB_SETITEMHEIGHT = (339);
const int CB_SETLOCALE = (345);
const int CB_SETTOPINDEX = (348);
const int CB_SHOWDROPDOWN = (335);

const int CBN_SELCHANGE = (1);

const int CBS_DROPDOWN = (0x2);
const int CBS_DROPDOWNLIST = (0x3);

const int CC_ENABLEHOOK = (0x10);
const int CC_ENABLETEMPLATE = (0x20);
const int CC_ENABLETEMPLATE_HANDLE = (0x40);
const int CC_FULLOPEN = (0x2);
const int CC_PREVENTFULLOPEN = (0x4);
const int CC_RGBINIT = (0x1);
const int CC_SHOWHELP = (0x8);
const int CC_SOLIDCOLOR = (0x80);

const int CDERR_DIALOGFAILURE = (0xffff);
const int CDERR_FINDRESFAILURE = (6);
const int CDERR_INITIALIZATION = (2);
const int CDERR_LOADRESFAILURE = (7);
const int CDERR_LOADSTRFAILURE = (5);
const int CDERR_LOCKRESFAILURE = (8);
const int CDERR_MEMALLOCFAILURE = (9);
const int CDERR_MEMLOCKFAILURE = (10);
const int CDERR_NO_HINSTANCE = (4);
const int CDERR_NOHOOK = (11);
const int CDERR_NOTEMPLATE = (3);
const int CDERR_REGISTERMSGFAIL = (12);
const int CDERR_STRUCTSIZE = (1);
const int CFERR_MAXLESSTHANMIN = (0x2000)+(2);
const int CFERR_NOFONTS = (0x2000)+(1);

/* Clipboard formats. */
const int CF_BITMAP = (2);
const int CF_DIB = (8);
const int CF_PALETTE = (9);
const int CF_ENHMETAFILE = (14);
const int CF_METAFILEPICT = (3);
const int CF_OEMTEXT = (7);
const int CF_TEXT = (1);
const int CF_UNICODETEXT = (13);
const int CF_DIF = (5);
const int CF_DSPBITMAP = (130);
const int CF_DSPENHMETAFILE = (142);
const int CF_DSPMETAFILEPICT = (131);
const int CF_DSPTEXT = (129);
const int CF_GDIOBJFIRST = (768);
const int CF_GDIOBJLAST = (1023);
const int CF_HDROP = (15);
const int CF_LOCALE = (16);
const int CF_OWNERDISPLAY = (128);
const int CF_PENDATA = (10);
const int CF_PRIVATEFIRST = (512);
const int CF_PRIVATELAST = (767);
const int CF_RIFF = (11);
const int CF_SYLK = (4);
const int CF_WAVE = (12);
const int CF_TIFF = (6);

/* Font selector flags. */
const int CF_APPLY = (0x200);
const int CF_ANSIONLY = (0x400);
const int CF_BOTH = (0x3);
const int CF_TTONLY = (0x40000);
const int CF_EFFECTS = (0x100);
const int CF_ENABLEHOOK = (0x8);
const int CF_ENABLETEMPLATE = (0x10);
const int CF_ENABLETEMPLATE_HANDLE = (0x20);
const int CF_FIXEDPITCHONLY = (0x4000);
const int CF_FORCEFONTEXIST = (0x10000);
const int CF_INITTOLOGFONTSTRUCT = (0x40);
const int CF_LIMITSIZE = (0x2000);
const int CF_NOOEMFONTS = (0x800);
const int CF_NOFACESEL = (0x80000);
const int CF_NOSCRIPTSEL = (0x800000);
const int CF_NOSTYLESEL = (0x100000);
const int CF_NOSIZESEL = (0x200000);
const int CF_NOSIMULATIONS = (0x1000);
const int CF_NOVECTORFONTS = (0x800);
const int CF_NOVERTFONTS = (0x1000000);
const int CF_PRINTERFONTS = (0x2);
const int CF_SCALABLEONLY = (0x20000);
const int CF_SCREENFONTS = (0x1);
const int CF_SCRIPTSONLY = (0x400);
const int CF_SELECTSCRIPT = (0x400000);
const int CF_SHOWHELP = (0x4);
const int CF_USESTYLE = (0x80);
const int CF_WYSIWYG = (0x8000);

const int COLOR_BTNFACE = (15);
const int COLOR_WINDOW = (5);

const int CS_DROPSHADOW = 131072;
const int CS_HREDRAW = (2);
const int CS_OWNDC = (32);
const int CS_VREDRAW = (1);

//const int CW_USEDEFAULT = cast(int) (0x80000000);

const int DIB_RGB_COLORS = (0);

const int DT_BOTTOM = (8);
const int DT_CALC_RECT = (1024);
const int DT_CENTER = (1);
const int DT_EDITCONTROL = (8192);
const int DT_END_ELLIPSIS = (32768);
const int DT_PATH_ELLIPSIS = (16384);
const int DT_EXPANDTABS = (64);
const int DT_EXTERNALLEADING = (512);
const int DT_LEFT = (0);
const int DT_MODIFYSTRING = (65536);
const int DT_NOCLIP = (256);
const int DT_NOPREFIX = (2048);
const int DT_RIGHT = (2);
const int DT_RTLREADING = (131072);
const int DT_SINGLELINE = (32);
const int DT_TABSTOP = (128);
const int DT_TOP = (0);
const int DT_VCENTER = (4);
const int DT_WORDBREAK = (16);
const int DT_INTERNAL = (4096);

const int EDGE_BUMP = (9);
const int EDGE_ETCHED = (6);
const int EDGE_RAISED = (5);
const int EDGE_SUNKEN = (10);

const int EM_GETLIMITTEXT = (213);
const int EM_SETREADONLY = (207);
const int EN_CHANGE = (768);
const int EN_KILLFOCUS = (512);
const int EN_MAXTEXT = (1281);
const int EN_SETFOCUS = (256);
const int EN_UPDATE = (1024);

//const int ES_AUTOHSCROLL = (0x80);

/* _WIN32_FIND_DATA attributes. */
const int FILE_ATTRIBUTE_ARCHIVE = (32);
const int FILE_ATTRIBUTE_COMPRESSED = (2048);
const int FILE_ATTRIBUTE_NORMAL = (128);
const int FILE_ATTRIBUTE_DIRECTORY = (16);
const int FILE_ATTRIBUTE_HIDDEN = (2);
const int FILE_ATTRIBUTE_READONLY = (1);
const int FILE_ATTRIBUTE_SYSTEM = (4);
const int FILE_ATTRIBUTE_TEMPORARY = (256);

const int FNERR_BUFFERTOOSMALL = (0x3000)+(3);
const int FNERR_INVALIDFILENAME = (0x3000)+(2);
const int FNERR_SUBCLASSFAILURE = (0x3000)+(1);

const int FORMAT_MESSAGE_ALLOCATE_BUFFER = (256);
const int FORMAT_MESSAGE_IGNORE_INSERTS = (512);
const int FORMAT_MESSAGE_FROM_SYSTEM = (4096);

const int FRERR_BUFFERLENGTHZERO = (0x4000)+(1);

/* GlobalAlloc types. */
const int GMEM_FIXED = (0);
const int GMEM_MOVEABLE = (2);

const int GWL_STYLE = -((16));

const int _HKEY_CLASSES_ROOT = cast(int) (0x80000000);
const int _HKEY_CURRENT_USER = cast(int) (0x80000001);
const int _HKEY_LOCAL_MACHINE = cast(int) (0x80000002);
const int _HKEY_USERS = cast(int) (0x80000003);
const int _HKEY_PERFORMANCE_DATA = cast(int) (0x80000004);
const int _HKEY_CURRENT_CONFIG = cast(int) (0x80000005);
const int _HKEY_DYN_DATA = cast(int) (0x80000006);

const int HOLLOW_BRUSH = (5);

const int HOVER_DEFAULT = cast(int) 0xFFFFFFFF;

const int ICC_LISTVIEW_CLASSES = 0x00000001; // listview, header
const int ICC_TREEVIEW_CLASSES = 0x00000002; // treeview, tooltips
const int ICC_BAR_CLASSES = 0x00000004; // toolbar, statusbar, trackbar, tooltips
const int ICC_TAB_CLASSES = 0x00000008; // tab, tooltips
const int ICC_UPDOWN_CLASS = 0x00000010; // updown
const int ICC_PROGRESS_CLASS = 0x00000020; // progress
const int ICC_HOTKEY_CLASS = 0x00000040; // hotkey
const int ICC_ANIMATE_CLASS = 0x00000080; // animate
const int ICC_WIN95_CLASSES = 0x000000FF;
const int ICC_DATE_CLASSES = 0x00000100; // month picker, date picker, time picker, updown
const int ICC_USEREX_CLASSES = 0x00000200; // comboex
const int ICC_COOL_CLASSES = 0x00000400; // rebar (coolbar) control
const int ICC_INTERNET_CLASSES = 0x00000800;
const int ICC_PAGESCROLLER_CLASS = 0x00001000;   // page scroller
const int ICC_NATIVEFNTCTL_CLASS = 0x00002000;   // native font control

/* MessageBox return values */
const int IDABORT = (3);
const int IDCANCEL = (2);
const int IDCLOSE = (8);
const int IDHELP = (9);
const int IDIGNORE = (5);
const int IDNO = (7);
const int IDOK = (1);
const int IDRETRY = (4);
const int IDYES = (6);

const int LANG_NEUTRAL = (0);

/* _WIN32_FIND_DATA */
const int MAX_PATH = (260);

/* MessageBox types. */
const int MB_USERICON = (0x80);
const int MB_ICONASTERISK = (0x40);
const int MB_ICONEXCLAMATION = (0x30);
const int MB_ICONWARNING = (0x30);
const int MB_ICONERROR = (0x10);
const int MB_ICONHAND = (0x10);
const int MB_ICONQUESTION = (0x20);
const int MB_OK = (0);
const int MB_ABORTRETRYIGNORE = (0x2);
const int MB_APPLMODAL = (0);
const int MB_DEFAULT_DESKTOP_ONLY = (0x20000);
const int MB_HELP = (0x4000);
const int MB_RIGHT = (0x80000);
const int MB_RTLREADING = (0x100000);
const int MB_TOPMOST = (0x40000);
const int MB_DEFBUTTON1 = (0);
const int MB_DEFBUTTON2 = (0x100);
const int MB_DEFBUTTON3 = (0x200);
const int MB_DEFBUTTON4 = (0x300);
const int MB_ICONINFORMATION = (0x40);
const int MB_ICONSTOP = (0x10);
const int MB_OKCANCEL = (0x1);
const int MB_RETRYCANCEL = (0x5);
const int MB_SERVICE_NOTIFICATION = (0x40000);
const int MB_SETFOREGROUND = (0x10000);
const int MB_SYSTEMMODAL = (0x1000);
const int MB_TASKMODAL = (0x2000);
const int MB_YESNO = (0x4);
const int MB_YESNOCANCEL = (0x3);

const int MF_POPUP = (0x10);
const int MF_SEPARATOR = (0x800);
const int MF_STRING = (0);

const int MFS_CHECKED = (0x8);
const int MFS_UNCHECKED = (0);
const int MFS_DISABLED = (0x3);
const int MFS_ENABLED = (0);
const int MFS_HILITE = (0x80);
const int MFS_UNHILITE = (0);

const int MIIM_STATE = (1);

const int MK_CONTROL = (8);
const int MK_LBUTTON = (1);
const int MK_MBUTTON = (16);
const int MK_RBUTTON = (2);
const int MK_SHIFT = (4);

const int OFN_ALLOWMULTISELECT = (0x200);
const int OFN_CREATEPROMPT = (0x2000);
const int OFN_ENABLEHOOK = (0x20);
const int OFN_ENABLETEMPLATE = (0x40);
const int OFN_ENABLETEMPLATE_HANDLE = (0x80);
const int OFN_EXPLORER = (0x80000);
const int OFN_EXTENSIONDIFFERENT = (0x400);
const int OFN_FILEMUSTEXIST = (0x1000);
const int OFN_HIDEREADONLY = (0x4);
const int OFN_LONGNAMES = (0x200000);
const int OFN_NOCHANGEDIR = (0x8);
const int OFN_NODEREFERENCELINKS = (0x100000);
const int OFN_NO_LONGNAMES = (0x40000);
const int OFN_NONETWORKBUTTON = (0x20000);
const int OFN_NOREADONLYRETURN = (0x8000);
const int OFN_NOTESTFILECREATE = (0x10000);
const int OFN_NOVALIDATE = (0x100);
const int OFN_OVERWRITEPROMPT = (0x2);
const int OFN_PATHMUSTEXIST = (0x800);
const int OFN_READONLY = (0x1);
const int OFN_SHAREAWARE = (0x4000);
const int OFN_SHOWHELP = (0x10);
const int OFN_SHAREFALLTHROUGH = (0x2);
const int OFN_SHARENOWARN = (0x1);
const int OFN_SHAREWARN = (0);

const int PDERR_CREATEICFAILURE = (0x1000)+(10);
const int PDERR_DEFAULTDIFFERENT = (0x1000)+(12);
const int PDERR_DNDMMISMATCH = (0x1000)+(9);
const int PDERR_GETDEVMODEFAIL = (0x1000)+(5);
const int PDERR_INITFAILURE = (0x1000)+(6);
const int PDERR_LOADDRVFAILURE = (0x1000)+(4);
const int PDERR_NODEFAULTPRN = (0x1000)+(8);
const int PDERR_NODEVICES = (0x1000)+(7);
const int PDERR_PARSEFAILURE = (0x1000)+(2);
const int PDERR_PRINTERNOTFOUND = (0x1000)+(11);
const int PDERR_RETDEFFAILURE = (0x1000)+(3);
const int PDERR_SETUPFAILURE = (0x1000)+(1);

const int PFD_DOUBLEBUFFER = (0x1);
const int PFD_DRAW_TO_WINDOW = (0x4);
const int PFD_MAIN_PLANE = (0);
const int PFD_SUPPORT_OPENGL = (0x20);
const int PFD_TYPE_RGBA = (0);

const int PS_DASH = (1);
const int PS_DASHDOT = (3);
const int PS_DASHDOTDOT = (4);
const int PS_DOT = (2);
const int PS_NULL = (5);
const int PS_SOLID = (0);

const int REG_EXPAND_SZ = (2);
const int REG_SZ = (1);

const int SB_BOTH = (3);
const int SB_BOTTOM = (7);
const int SB_CTL = (2);
const int SB_ENDSCROLL = (8);
const int SB_HORZ = (0);
const int SB_LEFT = (6);
const int SB_LINEUP = (0);
const int SB_LINEDOWN = (1);
const int SB_LINELEFT = (0);
const int SB_LINERIGHT = (1);
const int SB_PAGEUP = (2);
const int SB_PAGEDOWN = (3);
const int SB_PAGELEFT = (2);
const int SB_PAGERIGHT = (3);
const int SB_RIGHT = (7);
const int SB_THUMBPOSITION = (4);
const int SB_THUMBTRACK = (5);
const int SB_TOP = (6);
const int SB_VERT = (1);

const int SIF_RANGE = 0x0001;
const int SIF_PAGE = 0x0002;
const int SIF_POS = 0x0004;
const int SIF_DISABLENOSCROLL = 0x0008;
const int SIF_TRACKPOS = 0x0010;
const int SIF_ALL = SIF_RANGE | SIF_PAGE | SIF_POS | SIF_TRACKPOS;

const int SIZE_MAXHIDE = (4);
const int SIZE_MAXIMIZED = (2);
const int SIZE_MAXSHOW = (3);
const int SIZE_MINIMIZED = (1);
const int SIZE_RESTORED = (0);

const int SRCCOPY = (0x00CC0020);

/* Static control styles. */
const int SS_BITMAP = (0xe);
const int SS_BLACKFRAME = (0x7);
const int SS_BLACKRECT = (0x4);
const int SS_CENTER = (0x1);
const int SS_CENTERIMAGE = (0x200);
const int SS_ENHMETAFILE = (0xf);
const int SS_ETCHEDFRAME = (0x12);
const int SS_ETCHEDHORZ = (0x10);
const int SS_ETCHEDVERT = (0x11);
const int SS_GRAYFRAME = (0x8);
const int SS_GRAYRECT = (0x5);
const int SS_ICON = (0x3);
const int SS_LEFT = (0);
const int SS_LEFTNO_WORDWRAP = (0xc);
const int SS_NOPREFIX = (0x80);
const int SS_NOTIFY = (0x100);
const int SS_OWNERDRAW = (0xd);
const int SS_REALSIZEIMAGE = (0x800);
const int SS_RIGHT = (0x2);
const int SS_RIGHTJUST = (0x400);
const int SS_SIMPLE = (0xb);
const int SS_SUNKEN = (0x1000);
const int SS_USERITEM = (0xa);
const int SS_WHITEFRAME = (0x9);
const int SS_WHITERECT = (0x6);

const int SUBLANG_DEFAULT = (1);

const int SW_HIDE = (0);
const int SW_MAXIMIZE = (3);
const int SW_MINIMIZE = (6);
const int SW_NORMAL = (1);
const int SW_RESTORE = (9);
const int SW_SHOW = (5);
const int SW_SHOWDEFAULT = (10);
const int SW_SHOWMAXIMIZED = (3);
const int SW_SHOWMINIMIZED = (2);
const int SW_SHOWMINNOACTIVE = (7);
const int SW_SHOWNA = (8);
const int SW_SHOWNOACTIVATE = (4);
const int SW_SHOWNORMAL = (1);

const int TA_BASELINE = (24);
const int TA_BOTTOM = (8);
const int TA_TOP = (0);
const int TA_CENTER = (6);
const int TA_LEFT = (0);
const int TA_RIGHT = (2);

const int TME_HOVER = 0x00000001;
const int TME_LEAVE = 0x00000002;
const int TME_QUERY = 0x40000000;
const int TME_CANCEL = cast(int) 0x80000000;

const int TPM_RETURNCMD = (0x100);

const int TRANSPARENT = (1);

const int TTS_ALWAYSTIP = (1);
const int TTS_NOPREFIX = (2);

const int VK_0 = (48);
const int VK_1 = (49);
const int VK_2 = (50);
const int VK_3 = (51);
const int VK_4 = (52);
const int VK_5 = (53);
const int VK_6 = (54);
const int VK_7 = (55);
const int VK_8 = (56);
const int VK_9 = (57);

const int VK_A = (65);
const int VK_B = (66);
const int VK_C = (67);
const int VK_D = (68);

const int VK_ADD = (107);
const int VK_BACK = (8);
const int VK_CANCEL = (3);
const int VK_CAPITAL = (20);
const int VK_CLEAR = (12);
const int VK_CONTROL = (17);
const int VK_DECIMAL = (110);
const int VK_DELETE = (46);
const int VK_DIVIDE = (111);
const int VK_DOWN = (40);
const int VK_E = (69);
const int VK_END = (35);
const int VK_ESCAPE = (27);
const int VK_EXECUTE = (43);
const int VK_F = (70);
const int VK_F1 = (112);
const int VK_F2 = (113);
const int VK_F3 = (114);
const int VK_F4 = (115);
const int VK_F5 = (116);
const int VK_F6 = (117);
const int VK_F7 = (118);
const int VK_F8 = (119);
const int VK_F9 = (120);
const int VK_F10 = (121);
const int VK_F11 = (122);
const int VK_F12 = (123);
const int VK_F13 = (124);
const int VK_F14 = (125);
const int VK_F15 = (126);
const int VK_F16 = (127);
const int VK_F17 = (128);
const int VK_F18 = (129);
const int VK_F19 = (130);
const int VK_F20 = (131);
const int VK_F21 = (132);
const int VK_F22 = (133);
const int VK_F23 = (134);
const int VK_F24 = (135);
const int VK_G = (71);
const int VK_H = (72);
const int VK_HELP = (47);
const int VK_HOME = (36);
const int VK_I = (73);
const int VK_INSERT = (45);
const int VK_J = (74);
const int VK_K = (75);
const int VK_L = (76);
const int VK_LBUTTON = (1);
const int VK_LEFT = (37);
const int VK_M = (77);
const int VK_MBUTTON = (4);
const int VK_MENU = (18);
const int VK_MULTIPLY = (106);
const int VK_N = (78);
const int VK_NEXT = (34);
const int VK_NUMPAD0 = (96);
const int VK_NUMPAD1 = (97);
const int VK_NUMPAD2 = (98);
const int VK_NUMPAD3 = (99);
const int VK_NUMPAD4 = (100);
const int VK_NUMPAD5 = (101);
const int VK_NUMPAD6 = (102);
const int VK_NUMPAD7 = (103);
const int VK_NUMPAD8 = (104);
const int VK_NUMPAD9 = (105);
const int VK_O = (79);
const int VK_P = (80);
const int VK_PAUSE = (19);
const int VK_PRINT = (42);
const int VK_PRIOR = (33);
const int VK_Q = (81);
const int VK_R = (82);
const int VK_RBUTTON = (2);
const int VK_RETURN = (13);
const int VK_RIGHT = (39);
const int VK_S = (83);
const int VK_SELECT = (41);
const int VK_SEPARATOR = (108);
const int VK_SHIFT = (16);
const int VK_SNAPSHOT = (44);
const int VK_SPACE = (32);
const int VK_SUBTRACT = (109);
const int VK_T = (84);
const int VK_TAB = (9);
const int VK_U = (85);
const int VK_UP = (38);
const int VK_V = (86);
const int VK_W = (87);
const int VK_X = (88);
const int VK_Y = (89);
const int VK_Z = (90);

const int VK_NUMLOCK = (144);
const int VK_SCROLL = (145);
const int VK_LSHIFT = (160);
const int VK_LCONTROL = (162);
const int VK_LMENU = (164);
const int VK_RSHIFT = (161);
const int VK_RCONTROL = (163);
const int VK_RMENU = (165);
const int VK_PROCESSKEY = (229);

/* WM_ACTIVATE states */
const int WA_ACTIVE = (1);
const int WA_CLICKACTIVE = (2);
const int WA_INACTIVE = (0);

const int WHEEL_DELTA = 120;

const int WM_ACTIVATE = (6);
const int WM_ACTIVATEAPP = (28);
const int WM_CHAR = (258);
const int WM_CLOSE = (16);
const int WM_COMMAND = (273);
const int WM_CONTEXTMENU = (123);
const int WM_CREATE = (1);
const int WM_CTLCOLORBTN = (309);
const int WM_CTLCOLORSTATIC = (312);
const int WM_DESTROY = (2);
const int WM_DROPFILES = (563);
const int WM_ERASEBKGND = (20);
const int WM_GETFONT = (49);
const int WM_GETICON = (127);
const int WM_GETMINMAXINFO = (36);
const int WM_GETTEXT = (13);
const int WM_GETTEXTLENGTH = (14);
const int WM_HELP = (83);
const int WM_HSCROLL = (276);
const int WM_KEYDOWN = (256);
const int WM_KEYUP = (257);
const int WM_KILLFOCUS = (8);
const int WM_LBUTTONDOWN = (513);
const int WM_LBUTTONUP = (514);
const int WM_MBUTTONDOWN = (519);
const int WM_MBUTTONUP = (520);
const int WM_MOUSEACTIVATE = (33);
const int WM_MOUSELEAVE = (0x02A3);
const int WM_MOUSEMOVE = (512);
const int WM_MOUSEWHEEL = (522);
const int WM_MOVE = (3);
const int WM_NCACTIVATE = (134);
const int WM_NCCALCSIZE = (131);
const int WM_NCCREATE = (129);
const int WM_NCDESTROY = (130);
const int WM_NCHITTEST = (132);
const int WM_NCLBUTTONDOWN = (161);
const int WM_NCLBUTTONUP = (162);
const int WM_NCMOUSELEAVE = (674);
const int WM_NCMOUSEMOVE = (160);
const int WM_NCPAINT = (133);
const int WM_PAINT = (15);
const int WM_PARENTNOTIFY = (528);
const int WM_RBUTTONDOWN = (516);
const int WM_RBUTTONUP = (517);
const int WM_SETCURSOR = (32);
const int WM_SETFOCUS = (7);
const int WM_SETTEXT = (12);
const int WM_SHOWWINDOW = (24);
const int WM_SIZE = (5);
const int WM_SETFONT = (48);
const int WM_SYSCOMMAND = (274);
const int WM_TIMER = (275);
const int WM_VSCROLL = (277);
const int WM_WINDOWPOSCHANGED = (71);
const int WM_WINDOWPOSCHANGING = (70);

const int WS_BORDER = (0x800000);
const int WS_CAPTION = (0xc00000);
const int WS_CHILD = (0x40000000);
const int WS_CHILDWINDOW = (0x40000000);
const int WS_CLIPCHILDREN = (0x2000000);
const int WS_CLIPSIBLINGS = (0x4000000);
const int WS_DISABLED = (0x8000000);
const int WS_DLGFRAME = (0x400000);
const int WS_GROUP = (0x20000);
const int WS_HSCROLL = (0x100000);
const int WS_ICONIC = (0x20000000);
const int WS_MAXIMIZE = (0x1000000);
const int WS_MAXIMIZEBOX = (0x10000);
const int WS_MINIMIZE = (0x20000000);
const int WS_MINIMIZEBOX = (0x20000);
const int WS_OVERLAPPED = (0);
const int WS_OVERLAPPEDWINDOW = (0xcf0000);
const int WS_POPUP = cast(int) (0x80000000);
const int WS_POPUPWINDOW = cast(int) (0x80880000);
const int WS_SIZEBOX = (0x40000);
const int WS_SYSMENU = (0x80000);
const int WS_TABSTOP = (0x10000);
const int WS_THICKFRAME = (0x40000);
const int WS_TILED = (0);
const int WS_TILEDWINDOW = (0xcf0000);
const int WS_VISIBLE = (0x10000000);
const int WS_VSCROLL = (0x200000);

const char* IDC_ARROW = cast(char*) ((32512));
const char* IDC_IBEAM = cast(char*) ((32513));
const char* IDC_WAIT = cast(char*) ((32514));
const char* IDC_CROSS = cast(char*) ((32515));
const char* IDC_UPARROW = cast(char*) ((32516));
const char* IDC_SIZENWSE = cast(char*) ((32642));
const char* IDC_SIZENESW = cast(char*) ((32643));
const char* IDC_SIZEWE = cast(char*) ((32644));
const char* IDC_SIZENS = cast(char*) ((32645));
const char* IDC_SIZEALL = cast(char*) ((32646));
const char* IDC_NO = cast(char*) ((32648));
const char* IDC_APPSTARTING = cast(char*) ((32650));
const char* IDC_HELP = cast(char*) ((32651));
const char* IDI_APPLICATION = cast(char*) ((32512));
const char* IDI_HAND = cast(char*) ((32513));
const char* IDI_QUESTION = cast(char*) ((32514));
const char* IDI_EXCLAMATION = cast(char*) ((32515));
const char* IDI_ASTERISK = cast(char*) ((32516));
const char* IDI_WINLOGO = cast(char*) ((32517));
const char* IDC_SIZE = cast(char*) ((32640));
const char* IDC_ICON = cast(char*) ((32641));

/* field selection bits */
const int DM_ORIENTATION      = 0x00000001L;
const int DM_PAPERSIZE        = 0x00000002L;
const int DM_PAPERLENGTH      = 0x00000004L;
const int DM_PAPERWIDTH       = 0x00000008L;
const int DM_SCALE            = 0x00000010L;
//#if(WINVER >= 0x0500)
const int DM_POSITION         = 0x00000020L;
//#endif /* WINVER >= 0x0500 */
const int DM_COPIES           = 0x00000100L;
const int DM_DEFAULTSOURCE    = 0x00000200L;
const int DM_PRINTQUALITY     = 0x00000400L;
const int DM_COLOR            = 0x00000800L;
const int DM_DUPLEX           = 0x00001000L;
const int DM_YRESOLUTION      = 0x00002000L;
const int DM_TTOPTION         = 0x00004000L;
const int DM_COLLATE          = 0x00008000L;
const int DM_FORMNAME         = 0x00010000L;
const int DM_LOGPIXELS        = 0x00020000L;
const int DM_BITSPERPEL       = 0x00040000L;
const int DM_PELSWIDTH        = 0x00080000L;
const int DM_PELSHEIGHT       = 0x00100000L;
const int DM_DISPLAYFLAGS     = 0x00200000L;
const int DM_DISPLAYFREQUENCY = 0x00400000L;
//#if(WINVER >= 0x0400)
const int DM_ICMMETHOD        = 0x00800000L;
const int DM_ICMINTENT        = 0x01000000L;
const int DM_MEDIATYPE        = 0x02000000L;
const int DM_DITHERTYPE       = 0x04000000L;
const int DM_PANNINGWIDTH     = 0x08000000L;
const int DM_PANNINGHEIGHT    = 0x10000000L;
//#endif /* WINVER >= 0x0400 */

/* Flags for ChangeDisplaySettings */
const int CDS_UPDATEREGISTRY  = 0x00000001;
const int CDS_TEST            = 0x00000002;
const int CDS_FULLSCREEN      = 0x00000004;
const int CDS_GLOBAL          = 0x00000008;
const int CDS_SET_PRIMARY     = 0x00000010;
const int CDS_RESET           = 0x40000000;
const int CDS_SET_RECT         = 0x20000000;
const int CDS_NORESET         = 0x10000000;

const int WS_EX_DLGMODALFRAME     = 0x00000001L;
const int WS_EX_NOPARENTNOTIFY    = 0x00000004L;
const int WS_EX_TOPMOST           = 0x00000008L;
const int WS_EX_ACCEPTFILES       = 0x00000010L;
const int WS_EX_TRANSPARENT       = 0x00000020L;
//#if(WINVER >= 0x0400)
const int WS_EX_MDICHILD          = 0x00000040L;
const int WS_EX_TOOLWINDOW        = 0x00000080L;
const int WS_EX_WINDOWEDGE        = 0x00000100L;
const int WS_EX_CLIENTEDGE        = 0x00000200L;
const int WS_EX_CONTEXTHELP       = 0x00000400L;

const int WS_EX_RIGHT             = 0x00001000L;
const int WS_EX_LEFT              = 0x00000000L;
const int WS_EX_RTLREADING        = 0x00002000L;
const int WS_EX_LTRREADING        = 0x00000000L;
const int WS_EX_LEFTSCROLLBAR     = 0x00004000L;
const int WS_EX_RIGHTSCROLLBAR    = 0x00000000L;

const int WS_EX_CONTROLPARENT     = 0x00010000L;
const int WS_EX_STATICEDGE        = 0x00020000L;
const int WS_EX_APPWINDOW         = 0x00040000L;

const int WS_EX_OVERLAPPEDWINDOW = (WS_EX_WINDOWEDGE | WS_EX_CLIENTEDGE);
const int WS_EX_PALETTEWINDOW = (WS_EX_WINDOWEDGE | WS_EX_TOOLWINDOW | WS_EX_TOPMOST);
//#endif /* WINVER >= 0x0400 */

/* Values for GetSystemMetrics */
const int SM_CXSCREEN = 0;
const int SM_CYSCREEN = 1;
const int SM_CXVSCROLL = 2;
const int SM_CYHSCROLL = 3;
const int SM_CYCAPTION = 4;
const int SM_CXBORDER = 5;
const int SM_CYBORDER = 6;
const int SM_CXDLGFRAME = 7;
const int SM_CYDLGFRAME = 8;
const int SM_CYVTHUMB = 9;
const int SM_CXHTHUMB = 10;
const int SM_CXICON = 11;
const int SM_CYICON = 12;
const int SM_CXCURSOR = 13;
const int SM_CYCURSOR = 14;
const int SM_CYMENU = 15;
const int SM_CXFULLSCREEN = 16;
const int SM_CYFULLSCREEN = 17;
const int SM_CYKANJIWINDOW = 18;
const int SM_MOUSEPRESENT = 19;
const int SM_CYVSCROLL = 20;
const int SM_CXHSCROLL = 21;
const int SM_DEBUG = 22;
const int SM_SWAPBUTTON = 23;
const int SM_RESERVED1 = 24;
const int SM_RESERVED2 = 25;
const int SM_RESERVED3 = 26;
const int SM_RESERVED4 = 27;
const int SM_CXMIN = 28;
const int SM_CYMIN = 29;
const int SM_CXSIZE = 30;
const int SM_CYSIZE = 31;
const int SM_CXFRAME = 32;
const int SM_CYFRAME = 33;
const int SM_CXMINTRACK = 34;
const int SM_CYMINTRACK = 35;
const int SM_CXDOUBLECLK = 36;
const int SM_CYDOUBLECLK = 37;
const int SM_CXICONSPACING = 38;
const int SM_CYICONSPACING = 39;
const int SM_MENUDROPALIGNMENT = 40;
const int SM_PENWINDOWS = 41;
const int SM_DBCSENABLED = 42;
const int SM_CMOUSEBUTTONS = 43;

const int _P_WAIT = 0;
const int _P_NOWAIT = 1;
const int _OLD_P_OVERLAY = 2;
const int _P_NOWAITO = 3;
const int _P_DETACH = 4;

const int DEBUG_PROCESS = 0x00000001;
const int DEBUG_ONLY_THIS_PROCESS = 0x00000002;

const int CREATE_SUSPENDED = 0x00000004;

const int DETACHED_PROCESS = 0x00000008;

const int CREATE_NEW_CONSOLE = 0x00000010;

const int NORMAL_PRIORITY_CLASS = 0x00000020;
const int IDLE_PRIORITY_CLASS = 0x00000040;
const int HIGH_PRIORITY_CLASS = 0x00000080;
const int REALTIME_PRIORITY_CLASS = 0x00000100;

const int CREATE_NEW_PROCESS_GROUP = 0x00000200;
const int CREATE_UNICODE_ENVIRONMENT = 0x00000400;

const int CREATE_SEPARATE_WOW_VDM = 0x00000800;
const int CREATE_SHARED_WOW_VDM = 0x00001000;
const int CREATE_FORCEDOS = 0x00002000;

const int BELOW_NORMAL_PRIORITY_CLASS = 0x00004000;
const int ABOVE_NORMAL_PRIORITY_CLASS = 0x00008000;
const int STACK_SIZE_PARAM_IS_A_RESERVATION = 0x00010000;

const int CREATE_BREAKAWAY_FROM_JOB = 0x01000000;
const int CREATE_PRESERVE_CODE_AUTHZ_LEVEL = 0x02000000;

const int CREATE_DEFAULT_ERROR_MODE = 0x04000000;
const int CREATE_NO_WINDOW = 0x08000000;

const int PROFILE_USER = 0x10000000;
const int PROFILE_KERNEL = 0x20000000;
const int PROFILE_SERVER = 0x40000000;

const int CREATE_IGNORE_SYSTEM_DEFAULT = cast(int) 0x80000000;

const int EXCEPTION_DEBUG_EVENT = 1;
const int CREATE_THREAD_DEBUG_EVENT = 2;
const int CREATE_PROCESS_DEBUG_EVENT = 3;
const int EXIT_THREAD_DEBUG_EVENT = 4;
const int EXIT_PROCESS_DEBUG_EVENT = 5;
const int LOAD_DLL_DEBUG_EVENT = 6;
const int UNLOAD_DLL_DEBUG_EVENT = 7;
const int OUTPUT_DEBUG_STRING_EVENT = 8;
const int RIP_EVENT = 9;

const int EXCEPTION_MAXIMUM_PARAMETERS = 15;

const _DWORD STATUS_WAIT_0 = 0x00000000;
const _DWORD STATUS_ABANDONED_WAIT_0 = 0x00000080;
const _DWORD STATUS_USER_APC = 0x000000C0;
const _DWORD STATUS_TIMEOUT = 0x00000102;
const _DWORD STATUS_PENDING = 0x00000103;
const _DWORD DBG_EXCEPTION_HANDLED = 0x00010001;
const _DWORD DBG_CONTINUE = 0x00010002;
const _DWORD STATUS_SEGMENT_NOTIFICATION = 0x40000005;
const _DWORD DBG_TERMINATE_THREAD = 0x40010003;
const _DWORD DBG_TERMINATE_PROCESS = 0x40010004;
const _DWORD DBG_CONTROL_C = 0x40010005;
const _DWORD DBG_CONTROL_BREAK = 0x40010008;
const _DWORD STATUS_GUARD_PAGE_VIOLATION = 0x80000001;
const _DWORD STATUS_DATATYPE_MISALIGNMENT = 0x80000002;
const _DWORD STATUS_BREAK_POINT = 0x80000003;
const _DWORD STATUS_SINGLE_STEP = 0x80000004;
const _DWORD DBG_EXCEPTION_NOT_HANDLED = 0x80010001;
const _DWORD STATUS_ACCESS_VIOLATION = 0xC0000005;
const _DWORD STATUS_IN_PAGE_ERROR = 0xC0000006;
const _DWORD STATUS_INVALID_HANDLE = 0xC0000008;
const _DWORD STATUS_NO_MEMORY = 0xC0000017;
const _DWORD STATUS_ILLEGAL_INSTRUCTION = 0xC000001D;
const _DWORD STATUS_NONCONTINUABLE_EXCEPTION = 0xC0000025;
const _DWORD STATUS_INVALID_DISPOSITION = 0xC0000026;
const _DWORD STATUS_ARRAY_BOUNDS_EXCEEDED = 0xC000008C;
const _DWORD STATUS_FLOAT_DENORMAL_OPERAND = 0xC000008D;
const _DWORD STATUS_FLOAT_DIVIDE_BY_ZERO = 0xC000008E;
const _DWORD STATUS_FLOAT_INEXACT_RESULT = 0xC000008F;
const _DWORD STATUS_FLOAT_INVALID_OPERATION = 0xC0000090;
const _DWORD STATUS_FLOAT_OVERFLOW = 0xC0000091;
const _DWORD STATUS_FLOAT_STACK_CHECK = 0xC0000092;
const _DWORD STATUS_FLOAT_UNDERFLOW = 0xC0000093;
const _DWORD STATUS_INTEGER_DIVIDE_BY_ZERO = 0xC0000094;
const _DWORD STATUS_INTEGER_OVERFLOW = 0xC0000095;
const _DWORD STATUS_PRIVILEGED_INSTRUCTION = 0xC0000096;
const _DWORD STATUS_STACK_OVERFLOW = 0xC00000FD;

const _DWORD EXCEPTION_ACCESS_VIOLATION = STATUS_ACCESS_VIOLATION;
const _DWORD EXCEPTION_DATATYPE_MISALIGNMENT = STATUS_DATATYPE_MISALIGNMENT;
const _DWORD EXCEPTION_BREAK_POINT = STATUS_BREAK_POINT;
const _DWORD EXCEPTION_SINGLE_STEP = STATUS_SINGLE_STEP;
const _DWORD EXCEPTION_ARRAY_BOUNDS_EXCEEDED = STATUS_ARRAY_BOUNDS_EXCEEDED;
const _DWORD EXCEPTION_FLT_DENORMAL_OPERAND = STATUS_FLOAT_DENORMAL_OPERAND;
const _DWORD EXCEPTION_FLT_DIVIDE_BY_ZERO = STATUS_FLOAT_DIVIDE_BY_ZERO;
const _DWORD EXCEPTION_FLT_INEXACT_RESULT = STATUS_FLOAT_INEXACT_RESULT;
const _DWORD EXCEPTION_FLT_INVALID_OPERATION = STATUS_FLOAT_INVALID_OPERATION;
const _DWORD EXCEPTION_FLT_OVERFLOW = STATUS_FLOAT_OVERFLOW;
const _DWORD EXCEPTION_FLT_STACK_CHECK = STATUS_FLOAT_STACK_CHECK;
const _DWORD EXCEPTION_FLT_UNDERFLOW = STATUS_FLOAT_UNDERFLOW;
const _DWORD EXCEPTION_INT_DIVIDE_BY_ZERO = STATUS_INTEGER_DIVIDE_BY_ZERO;
const _DWORD EXCEPTION_INT_OVERFLOW = STATUS_INTEGER_OVERFLOW;
const _DWORD EXCEPTION_PRIV_INSTRUCTION = STATUS_PRIVILEGED_INSTRUCTION;
const _DWORD EXCEPTION_IN_PAGE_ERROR = STATUS_IN_PAGE_ERROR;
const _DWORD EXCEPTION_ILLEGAL_INSTRUCTION = STATUS_ILLEGAL_INSTRUCTION;
const _DWORD EXCEPTION_NONCONTINUABLE_EXCEPTION = STATUS_NONCONTINUABLE_EXCEPTION;
const _DWORD EXCEPTION_STACK_OVERFLOW = STATUS_STACK_OVERFLOW;
const _DWORD EXCEPTION_INVALID_DISPOSITION = STATUS_INVALID_DISPOSITION;
const _DWORD EXCEPTION_GUARD_PAGE = STATUS_GUARD_PAGE_VIOLATION;
const _DWORD EXCEPTION_INVALID_HANDLE = STATUS_INVALID_HANDLE;

extern (Windows) typedef _DWORD function (_LPVOID lpThreadParameter) PTHREAD_START_ROUTINE;
alias PTHREAD_START_ROUTINE LPTHREAD_START_ROUTINE;

struct EXCEPTION_RECORD
{
    _DWORD    ExceptionCode;
    _DWORD ExceptionFlags;
    EXCEPTION_RECORD *ExceptionRecord;
    _PVOID ExceptionAddress;
    _DWORD NumberParameters;
    _ULONG_PTR ExceptionInformation[EXCEPTION_MAXIMUM_PARAMETERS];
}

struct EXCEPTION_DEBUG_INFO
{
    EXCEPTION_RECORD ExceptionRecord;
    _DWORD dwFirstChance;
}

alias EXCEPTION_DEBUG_INFO *LPEXCEPTION_DEBUG_INFO;

struct CREATE_THREAD_DEBUG_INFO
{
    _HANDLE hThread;
    _LPVOID lpThreadLocalBase;
    LPTHREAD_START_ROUTINE lpStartAddress;
}

alias CREATE_THREAD_DEBUG_INFO *LPCREATE_THREAD_DEBUG_INFO;

struct CREATE_PROCESS_DEBUG_INFO
{
    _HANDLE hFile;
    _HANDLE hProcess;
    _HANDLE hThread;
    _LPVOID lpBaseOfImage;
    _DWORD dwDebugInfoFileOffset;
    _DWORD nDebugInfoSize;
    _LPVOID lpThreadLocalBase;
    LPTHREAD_START_ROUTINE lpStartAddress;
    _LPVOID lpImageName;
    _WORD fUnicode;
}

alias CREATE_PROCESS_DEBUG_INFO *LPCREATE_PROCESS_DEBUG_INFO;

struct EXIT_THREAD_DEBUG_INFO
{
    _DWORD dwExitCode;
}

alias EXIT_THREAD_DEBUG_INFO *LPEXIT_THREAD_DEBUG_INFO;

struct EXIT_PROCESS_DEBUG_INFO
{
    _DWORD dwExitCode;
}

alias EXIT_PROCESS_DEBUG_INFO *LPEXIT_PROCESS_DEBUG_INFO;

struct LOAD_DLL_DEBUG_INFO
{
    _HANDLE hFile;
    _LPVOID lpBaseOfDll;
    _DWORD dwDebugInfoFileOffset;
    _DWORD nDebugInfoSize;
    _LPVOID lpImageName;
    _WORD fUnicode;
}

alias LOAD_DLL_DEBUG_INFO *LPLOAD_DLL_DEBUG_INFO;

struct UNLOAD_DLL_DEBUG_INFO
{
    _LPVOID lpBaseOfDll;
}

alias UNLOAD_DLL_DEBUG_INFO *LPUNLOAD_DLL_DEBUG_INFO;

struct OUTPUT_DEBUG_STRING_INFO
{
    _LPSTR lpDebugStringData;
    _WORD fUnicode;
    _WORD nDebugStringLength;
}

alias OUTPUT_DEBUG_STRING_INFO *LPOUTPUT_DEBUG_STRING_INFO;

struct RIP_INFO
{
    _DWORD dwError;
    _DWORD dwType;
}

alias RIP_INFO *LPRIP_INFO;

struct DEBUG_EVENT
{
    _DWORD dwDebugEventCode;
    _DWORD dwProcessId;
    _DWORD dwThreadId;

    union U
    {
        EXCEPTION_DEBUG_INFO Exception;
        CREATE_THREAD_DEBUG_INFO CreateThread;
        CREATE_PROCESS_DEBUG_INFO CreateProcessInfo;
        EXIT_THREAD_DEBUG_INFO ExitThread;
        EXIT_PROCESS_DEBUG_INFO ExitProcess;
        LOAD_DLL_DEBUG_INFO LoadDll;
        UNLOAD_DLL_DEBUG_INFO UnloadDll;
        OUTPUT_DEBUG_STRING_INFO DebugString;
        RIP_INFO RipInfo;
    }

    U u;
}

alias DEBUG_EVENT *LPDEBUG_EVENT;

struct NMHDR
{
	_HWND hwndFrom;
	_UINT idFrom;
	_UINT code;
}

struct SIZE
{
	_LONG cx;
	_LONG cy;
}

alias SIZE* LPSIZE;
alias SIZE TAGSIZE;
alias SIZE TSIZE;
alias SIZE* PSIZE;
alias SIZE SIZEL;
alias SIZE TSIZEL;
alias SIZE* PSIZEL;
alias SIZE* LPSIZEL;

struct VA_LIST
{
}

const int LF_FACESIZE = (32);

struct LOGFONT
{
	_LONG lfHeight;
	_LONG lfWidth;
	_LONG lfEscapement;
	_LONG lfOrientation;
	_LONG lfWeight;
	ubyte lfItalic;
	ubyte lfUnderline;
	ubyte lfStrikeOut;
	ubyte lfCharSet;
	ubyte lfOutPrecision;
	ubyte lfClipPrecision;
	ubyte lfQuality;
	ubyte lfPitchAndFamily;
	TCHAR[1 + LF_FACESIZE-1] lfFaceName;
}

alias LOGFONT* LPLOGFONT;
alias LOGFONT TLOGFONT;
alias LOGFONT TLOGFONTA;
alias LOGFONT* PLOGFONT;

struct OPENFILENAME
{
    _DWORD lStructSize;
	_HWND hwndOwner;
	HINST hInstance;
	_LPCTSTR lpstrFilter;
	_LPTSTR lpstrCustomFilter;
	_DWORD nMaxCustFilter;
	_DWORD nFilterIndex;
	_LPTSTR lpstrFile;
	_DWORD nMaxFile;
	_LPTSTR lpstrFileTitle;
	_DWORD nMaxFileTitle;
	_LPCTSTR lpstrInitialDir;
	_LPCTSTR lpstrTitle;
	_DWORD Flags;
	ushort nFileOffset;
	ushort nFileExtension;
	_LPCTSTR lpstrDefExt;
	_DWORD lCustData;
	LPOFNHOOKPROC lpfnHook;
	_LPCTSTR lpTemplateName;
}

alias OPENFILENAME* LPOPENFILENAME;
alias OPENFILENAME TOPENFILENAME;
alias OPENFILENAME* POPENFILENAME;
alias OPENFILENAME TAGOFN;
alias OPENFILENAME TOFN;
alias OPENFILENAME* POFN;

struct MENUITEMINFO
{
	_UINT cbSize;
	_UINT fMask;
	_UINT fType;
	_UINT fState;
	_UINT wID;
	_HMENU hSubMenu;
	_HBITMAP hbmpChecked;
	_HBITMAP hbmpUnchecked;
	_DWORD dwItemData;
	_LPTSTR dwTypeData;
	_UINT cch;
}

alias MENUITEMINFO* LPMENUITEMINFO;
alias MENUITEMINFO* LPCMENUITEMINFO;
alias MENUITEMINFO TAGMENUITEMINFO;
alias MENUITEMINFO TMENUITEMINFO;
alias MENUITEMINFO TMENUITEMINFOA;
alias MENUITEMINFO* PMENUITEMINFO;

struct TCHOOSEFONT
{
	_DWORD lStructSize;
	_HWND hwndOwner;
	_HDC hDC;
	LPLOGFONT lpLogFont;
	WININT iPointSize;
	_DWORD Flags;
	_DWORD rgbColors;
	_LPARAM lCustData;
	LPCFHOOKPROC lpfnHook;
	_LPCTSTR lpTemplateName;
	HINST hInstance;
	_LPTSTR lpszStyle;
	ushort nFontType;
	ushort __MISSING_ALIGNMENT_;
	WININT nSizeMin;
	WININT nSizeMax;
}

alias TCHOOSEFONT* LPCHOOSEFONT;
alias TCHOOSEFONT* PCHOOSEFONT;

struct TCHOOSECOLOR
{
	_DWORD lStructSize;
	_HWND hwndOwner;
	_HWND hInstance;
	_COLORREF rgbResult;
	_COLORREF* lpCustColors;
	_DWORD Flags;
	_LPARAM lCustData;
	LPCCHOOKPROC lpfnHook;
	_LPCTSTR lpTemplateName;
}

alias TCHOOSECOLOR* LPCHOOSECOLOR;
alias TCHOOSECOLOR* PCHOOSECOLOR;

struct HELPINFO
{
	_UINT cbSize;
	int iContextType;
	int iCtrlId;
	_HANDLE hItemHandle;
	_DWORD dwContextId;
	_POINT MousePos;
}

alias HELPINFO* LPHELPINFO;
alias HELPINFO TAGHELPINFO;
alias HELPINFO THELPINFO;
alias HELPINFO* PHELPINFO;

struct INITCOMMONCONTROLSEX
{
    _DWORD dwSize;             // size of this structure
    _DWORD dwICC;              // flags indicating which classes to be initialized
}

alias INITCOMMONCONTROLSEX *LPINITCOMMONCONTROLSEX;

struct TRACKMOUSEEVENT
{
    _DWORD cbSize;
    _DWORD dwFlags;
    _HWND hwndTrack;
    _DWORD dwHoverTime;
}

alias TRACKMOUSEEVENT *LPTRACKMOUSEEVENT;

struct TEXTMETRIC
{
	_LONG tmHeight;
	_LONG tmAscent;
	_LONG tmDescent;
	_LONG tmInternalLeading;
	_LONG tmExternalLeading;
	_LONG tmAveCharWidth;
	_LONG tmMaxCharWidth;
	_LONG tmWeight;
	_LONG tmOverhang;
	_LONG tmDigitizedAspectX;
	_LONG tmDigitizedAspectY;
	BCHAR tmFirstChar;
	BCHAR tmLastChar;
	BCHAR tmDefaultChar;
	BCHAR tmBreakChar;
	ubyte tmItalic;
	ubyte tmUnderlined;
	ubyte tmStruckOut;
	ubyte tmPitchAndFamily;
	ubyte tmCharSet;
}

alias TEXTMETRIC* LPTEXTMETRIC;
alias TEXTMETRIC TAGTEXTMETRIC;
alias TEXTMETRIC TTEXTMETRIC;
alias TEXTMETRIC* PTEXTMETRIC;

struct SCROLLINFO
{
    _UINT    cbSize;
    _UINT    fMask;
    int     nMin;
    int     nMax;
    _UINT    nPage;
    int     nPos;
    int     nTrackPos;
}

alias SCROLLINFO *LPSCROLLINFO;
alias SCROLLINFO *LPCSCROLLINFO;

struct MARGINS
{
    int cxLeftWidth;
    int cxRightWidth;
    int cyTopHeight;
    int cyBottomHeight;

    char [] toString () { return fmt ("[%d %d %d %d]", cxLeftWidth, cxRightWidth, cyTopHeight, cyBottomHeight); }
}

struct POINTL
{
    _LONG  x;
    _LONG  y;
}

alias POINTL *PPOINTL;

const int CCHDEVICENAME = 32; /* size of a device name string */
const int CCHFORMNAME = 32; /* size of a form name string */

struct DEVMODEA
{
    _BYTE[CCHDEVICENAME]   dmDeviceName;
    _WORD dmSpecVersion;
    _WORD dmDriverVersion;
    _WORD dmSize;
    _WORD dmDriverExtra;
    _DWORD dmFields;
    union
    {
      struct
      {
        short dmOrientation;
        short dmPaperSize;
        short dmPaperLength;
        short dmPaperWidth;
      }
      POINTL dmPosition;
    }
    short dmScale;
    short dmCopies;
    short dmDefaultSource;
    short dmPrintQuality;
    short dmColor;
    short dmDuplex;
    short dmYResolution;
    short dmTTOption;
    short dmCollate;
    _BYTE[CCHFORMNAME]   dmFormName;
    _WORD   dmLogPixels;
    _DWORD  dmBitsPerPel;
    _DWORD  dmPelsWidth;
    _DWORD  dmPelsHeight;
    _DWORD  dmDisplayFlags;
    _DWORD  dmDisplayFrequency;

//#if(WINVER >= 0x0400)
    _DWORD  dmICMMethod;
    _DWORD  dmICMIntent;
    _DWORD  dmMediaType;
    _DWORD  dmDitherType;
    _DWORD  dmReserved1;
    _DWORD  dmReserved2;
//#if (WINVER >= 0x0500) || (_WIN32_WINNT >= 0x0400)
    _DWORD  dmPanningWidth;
    _DWORD  dmPanningHeight;
//#endif
//#endif /* WINVER >= 0x0400 */
}

alias DEVMODEA* PDEVMODEA;
alias DEVMODEA* NPDEVMODEA;
alias DEVMODEA* LPDEVMODEA;

struct STARTUPINFOA
{
    _DWORD   cb;
    _LPSTR   lpReserved;
    _LPSTR   lpDesktop;
    _LPSTR   lpTitle;
    _DWORD   dwX;
    _DWORD   dwY;
    _DWORD   dwXSize;
    _DWORD   dwYSize;
    _DWORD   dwXCountChars;
    _DWORD   dwYCountChars;
    _DWORD   dwFillAttribute;
    _DWORD   dwFlags;
    _WORD    wShowWindow;
    _WORD    cbReserved2;
    _LPBYTE  lpReserved2;
    _HANDLE  hStdInput;
    _HANDLE  hStdOutput;
    _HANDLE  hStdError;
}

alias STARTUPINFOA* LPSTARTUPINFOA;

struct PROCESS_INFORMATION
{
    _HANDLE hProcess;
    _HANDLE hThread;
    _DWORD dwProcessId;
    _DWORD dwThreadId;
}


alias PROCESS_INFORMATION* PPROCESS_INFORMATION;
alias PROCESS_INFORMATION* LPPROCESS_INFORMATION;

extern (C) int chdir(char *);
extern (C) char *getcwd(char *buffer, int maxlen);
extern (C) intptr_t spawnvp(int mode, char *cmdname, char **argv);
extern (C) char *getenv(char *varname);
extern (C) int putenv(char *envstring);
extern (C) int osver;

extern(Windows)
{
    _BOOL _TrackMouseEvent (LPTRACKMOUSEEVENT lpEventTrack);
    WINBOOL AppendMenuA(_HMENU, _UINT, _UINT, _LPCSTR);
    //_HDC BeginPaint(_HWND, _PAINTSTRUCT*);
    WINBOOL BitBlt(_HDC, int, int, int, int, _HDC, int, int, _DWORD);
    WINBOOL BringWindowToTop(_HWND);
    _LRESULT CallWindowProcA(_WNDPROC lpPrevWndFunc, _HWND hwnd, _UINT Msg, _WPARAM _WPARAM, _LPARAM _LPARAM);
    _LONG ChangeDisplaySettingsA(LPDEVMODEA, _DWORD);
    WINBOOL ChooseColorA(LPCHOOSECOLOR);
    WINBOOL ChooseFontA(LPCHOOSEFONT);
    int ChoosePixelFormat(_HDC, _PIXELFORMATDESCRIPTOR*);
    WINBOOL CloseClipboard();
    _LPSTR GetCommandLineA();
    WINBOOL CommDlgExtendedError ();
    _HBITMAP CreateCompatibleBitmap(_HDC, int, int);
    _HDC CreateCompatibleDC(_HDC);
    _HBITMAP CreateDIBSection(_HDC, _BITMAPINFO*, _UINT, _POINTER*, _HANDLE, _DWORD);
    _HFONT CreateFontIndirectA(LPLOGFONT);
    _HMENU CreateMenu();
    _HPEN CreatePen(int, int, _COLORREF);
    _HMENU CreatePopupMenu();
    _BOOL CreateProcessA(_LPCTSTR lpApplicationName, _LPTSTR lpCommandLine, _SECURITY_ATTRIBUTES *lpProcessAttributes, _SECURITY_ATTRIBUTES *lpThreadAttributes, _BOOL bInheritHandles, _DWORD dwCreationFlags, _LPVOID lpEnvironment, _LPCTSTR lpCurrentDirectory, LPSTARTUPINFOA lpStartupInfo, LPPROCESS_INFORMATION lpProcessInformation);
    _HRGN CreateRectRgn(int nLeftRect, int nTopRect, int nRightRect, int nBottomRect);
    _HBRUSH CreateSolidBrush(_COLORREF);
    _HWND CreateWindowExA(_DWORD, _LPCSTR, _LPCSTR, _DWORD, int, int, int, int, _HWND, _HMENU, HINST, _LPVOID);
    _HWND CreateWindowExW(_DWORD, _LPWSTR, _LPWSTR, _DWORD, int, int, int, int, _HWND, _HMENU, HINST, _LPVOID);
    _LRESULT DefWindowProcA(_HWND, _UINT, _WPARAM, _LPARAM);
    WINBOOL DeleteDC(_HDC);
    WINBOOL DeleteObject(_HGDIOBJ);
    WINBOOL DestroyMenu(_HMENU);
    WINBOOL DestroyWindow(_HWND);
    //_LONG DispatchMessageA(LPMSG);
    void DragAcceptFiles(_HWND, _BOOL);
    void DragFinish(HDROP);
    _UINT DragQueryFileA(HDROP, _UINT, PCHAR, _UINT);
    WINBOOL DragQuery_POINT(HDROP, _LPPOINT);
    WINBOOL DrawEdge(_HDC, _LPRECT, _UINT, _UINT);
    WINBOOL DrawFocusRect(_HDC, _RECT*);
    int DrawTextA(_HDC, _LPCSTR, int, _LPRECT, _UINT);
    WINBOOL Ellipse(_HDC, int, int, int, int);
    WINBOOL EmptyClipboard();
    WINBOOL EnableWindow(_HWND, WINBOOL);
    //WINBOOL EndPaint(_HWND, _PAINTSTRUCT*);
    void ExitProcess(_UINT);
    //WINBOOL FindClose(_HANDLE);
    //_HANDLE FindFirstFileA(_LPCSTR, WIN32_FIND_DATA*);
    //WINBOOL FindNextFileA(_HANDLE, WIN32_FIND_DATA*);
    _DWORD FormatMessageA(_DWORD, _LPCVOID, _DWORD, _DWORD, _LPSTR, _DWORD, VA_LIST);
    WINBOOL FreeLibrary(HINST);
    _UINT GetBoundsRect(_HDC _HDC, _LPRECT lprcBounds, _UINT flags);
    _HWND GetCapture();
    WINBOOL GetCharWidth32A(_HDC, _UINT, _UINT, _LPINT);
    _BOOL GetClassInfoA(_HINSTANCE _HINSTANCE, _LPCTSTR lpClassName, LP_WNDCLASS lp_WNDCLASS);
    int GetClipRgn(_HDC _HDC, _HRGN _HRGN);
    _HANDLE GetClipboardData(_UINT);
    //_HDC GetDC(_HWND);
    _BOOL GetExitCodeProcess(_HANDLE hProcess, _LPDWORD lpExitCode);
    _HWND GetFocus();
    WINSHORT GetKeyState(int);
    //_DWORD GetLastError();
    //WINBOOL GetMessageA(LPMSG, _HWND, _UINT, _UINT);
    //HMODULE GetModule_HANDLEA(_LPCSTR);
    int GetObjectA(_HGDIOBJ, int, _LPVOID);
    WINBOOL GetOpenFileNameA(LPOPENFILENAME);
    WINBOOL GetSaveFileNameA(LPOPENFILENAME);
    _BOOL GetScrollInfo(_HWND, int, LPSCROLLINFO);
    int GetScrollPos(_HWND, int);
    _HGDIOBJ GetStockObject(int);
    _DWORD GetSysColor(int);
    _HBRUSH GetSysColorBrush(int);
    int GetSystemMetrics(int);
    _DWORD GetTabbedTextExtentA(_HDC, _LPCSTR, int, int, _LPINT);
    _DWORD GetTabbedTextExtentW(_HDC, _LPWSTR, int, int, _LPINT);
    WINBOOL GetTextExtent_POINTA(_HDC, _LPCSTR, int, LPSIZE);
    WINBOOL GetTextMetricsA(_HDC, LPTEXTMETRIC);
    _DWORD GetTickCount();
    //WINBOOL GetClientRect(_HWND, _LPRECT);
    WINBOOL GetCursorPos(_LPPOINT);
    _BOOL GetUpdateRect(_HWND hwnd, _LPRECT _LPRECT, _BOOL bErase);
    //WINBOOL GetWindowRect(_HWND, _LPRECT);
    _HGLOBAL GlobalAlloc(_UINT, _DWORD);
    _LPVOID GlobalLock(_HGLOBAL);
    WINBOOL GlobalUnlock(_HGLOBAL);
    void InitCommonControls();
    _BOOL InitCommonControlsEx(LPINITCOMMONCONTROLSEX);
    //WINBOOL InvalidateRect(_HWND, _RECT*, WINBOOL);
    WINBOOL IsWindowEnabled(_HWND);
    WINBOOL IsWindowVisible(_HWND);
    WINBOOL KillTimer(_HWND, _UINT);
    _HCURSOR LoadCursorA(HINST, _LPCSTR);
    HLOCAL LocalFree(HLOCAL);
    int MessageBoxA(_HWND, _LPCSTR, _LPCSTR, _UINT);
    int MessageBoxW(_HWND, _LPWSTR, _LPWSTR, _UINT);
    WINBOOL MoveWindow(_HWND, int, int, int, int, WINBOOL);
    WINBOOL OpenClipboard(_HWND);
    WINBOOL Polygon(_HDC, _POINT*, int);
    WINBOOL Polyline(_HDC, _POINT*, int);
    WINBOOL QueryPerformanceFrequency(LARGE_INTEGER* lpFrequency);
    //WINBOOL QueryPerformanceCounter(LARGE_INTEGER* lpFrequency);
    WINBOOL Rectangle(_HDC, int, int, int, int);
    //_LONG RegCloseKey(_HKEY);
    _LONG RegCreateKeyA(_HKEY, _LPCSTR, _PHKEY);
    //ATOM RegisterClassA(_WNDCLASS*);
    _LONG RegQueryValueExA(_HKEY, _LPCSTR, _LPDWORD, std.c.windows.windows.LPDWORD, _LPBYTE, _LPDWORD);
    //_LONG RegSetValueExA(_HKEY, _LPCSTR, _DWORD, _DWORD, _LPBYTE, _DWORD);
    WINBOOL ReleaseCapture();
    int ReleaseDC(_HWND, _HDC);
    WINBOOL RoundRect(_HDC, int, int, int, int, int, int);
    _HGDIOBJ SelectObject(_HDC, std.c.windows.windows.HGDIOBJ);
    _LRESULT SendMessageA(_HWND, _UINT, _WPARAM, _LPARAM);
    _LRESULT SendMessageW(_HWND, _UINT, _WPARAM, _LPARAM);
    //int SetBkMode(_HDC, int);
    _HWND SetCapture(_HWND);
    _HANDLE SetClipboardData(_UINT, _HANDLE);
    _HCURSOR SetCursor(_HCURSOR _HCURSOR);
    _HWND SetFocus(_HWND);
    WINBOOL SetMenuItemInfoA(_HMENU, _UINT, WINBOOL, LPCMENUITEMINFO);
    WINBOOL SetPixelFormat(_HDC, int, _PPIXELFORMATDESCRIPTOR);
    int SetScrollInfo(_HWND, int, LPCSCROLLINFO, _BOOL);
    int SetScrollPos(_HWND, int, int, WINBOOL);
    WINBOOL SetScrollRange(_HWND, int, int, int, WINBOOL);
    //_UINT SetTextAlign(_HDC, _UINT);
    //_COLORREF SetTextColor(_HDC, _COLORREF);
    _UINT SetTimer(_HWND, _UINT, _UINT, TIMERPROC);
    _BOOL SetViewportOrgEx(_HDC _HDC, int X, int Y, _LPPOINT _LPPOINT);
    _LONG SetWindowLongA(_HWND, int, _LONG);
    WINBOOL ShowScrollBar(_HWND, int, WINBOOL);
    WINBOOL ShowWindow(_HWND, int);
    WINBOOL SwapBuffers(_HDC);
    WINBOOL TextOutA(_HDC, int, int, _LPCSTR, int);
    _BOOL TrackMouseEvent (LPTRACKMOUSEEVENT lpEventTrack);
    WINBOOL TrackPopupMenu(_HMENU, _UINT, int, int, int, _HWND, _RECT*);
    //WINBOOL TranslateMessage(LPMSG);
    //WINBOOL UpdateWindow(_HWND);
    //_BOOL ValidateRect(_HWND hwnd, _RECT *_LPRECT);
    _BOOL WaitForDebugEvent(LPDEBUG_EVENT lpDebugEvent, _DWORD dwMilliseconds);
}

_DWORD MAKELANGID (_WORD p, _WORD s) { return (s << 10) | p; }

/+
#endif
+/
